/**
 * <copyright>
 * </copyright>
 *

 */
package org.xtext.example.mydsl7.myDsl.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.xtext.example.mydsl7.myDsl.Effect;
import org.xtext.example.mydsl7.myDsl.Grounding;
import org.xtext.example.mydsl7.myDsl.Input;
import org.xtext.example.mydsl7.myDsl.Interface;
import org.xtext.example.mydsl7.myDsl.MyDslPackage;
import org.xtext.example.mydsl7.myDsl.ODM_OWLClass;
import org.xtext.example.mydsl7.myDsl.Output;
import org.xtext.example.mydsl7.myDsl.Plan;
import org.xtext.example.mydsl7.myDsl.Precondition;
import org.xtext.example.mydsl7.myDsl.RegistrationRole;
import org.xtext.example.mydsl7.myDsl.Resource;
import org.xtext.example.mydsl7.myDsl.Role;
import org.xtext.example.mydsl7.myDsl.SS_AgreementPlan;
import org.xtext.example.mydsl7.myDsl.SS_ExecutorPlan;
import org.xtext.example.mydsl7.myDsl.SS_FinderPlan;
import org.xtext.example.mydsl7.myDsl.SS_RegisterPlan;
import org.xtext.example.mydsl7.myDsl.SWS;
import org.xtext.example.mydsl7.myDsl.SWSInteractionViewpoint;
import org.xtext.example.mydsl7.myDsl.SemanticWebAgent;
import org.xtext.example.mydsl7.myDsl.Service;
import org.xtext.example.mydsl7.myDsl.WebService;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SWS Interaction Viewpoint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getSemanticwebagent <em>Semanticwebagent</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getSws <em>Sws</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getService <em>Service</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getWebservice <em>Webservice</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getPlan <em>Plan</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getRole <em>Role</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getWinterface <em>Winterface</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getWinput <em>Winput</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getOutput <em>Output</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getRegistrationrole <em>Registrationrole</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getPrecondition <em>Precondition</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getEffect <em>Effect</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getResource <em>Resource</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getProcess <em>Process</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getOwlowlclass <em>Owlowlclass</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getRegisterplan <em>Registerplan</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getFinder <em>Finder</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getAgree <em>Agree</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getExe <em>Exe</em>}</li>
 *   <li>{@link org.xtext.example.mydsl7.myDsl.impl.SWSInteractionViewpointImpl#getGrounding <em>Grounding</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SWSInteractionViewpointImpl extends MinimalEObjectImpl.Container implements SWSInteractionViewpoint
{
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The cached value of the '{@link #getSemanticwebagent() <em>Semanticwebagent</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSemanticwebagent()
   * @generated
   * @ordered
   */
  protected EList<SemanticWebAgent> semanticwebagent;

  /**
   * The cached value of the '{@link #getSws() <em>Sws</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSws()
   * @generated
   * @ordered
   */
  protected EList<SWS> sws;

  /**
   * The cached value of the '{@link #getService() <em>Service</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getService()
   * @generated
   * @ordered
   */
  protected EList<Service> service;

  /**
   * The cached value of the '{@link #getWebservice() <em>Webservice</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWebservice()
   * @generated
   * @ordered
   */
  protected EList<WebService> webservice;

  /**
   * The cached value of the '{@link #getPlan() <em>Plan</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPlan()
   * @generated
   * @ordered
   */
  protected EList<Plan> plan;

  /**
   * The cached value of the '{@link #getRole() <em>Role</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRole()
   * @generated
   * @ordered
   */
  protected EList<Role> role;

  /**
   * The cached value of the '{@link #getWinterface() <em>Winterface</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWinterface()
   * @generated
   * @ordered
   */
  protected EList<Interface> winterface;

  /**
   * The cached value of the '{@link #getWinput() <em>Winput</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWinput()
   * @generated
   * @ordered
   */
  protected EList<Input> winput;

  /**
   * The cached value of the '{@link #getOutput() <em>Output</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOutput()
   * @generated
   * @ordered
   */
  protected EList<Output> output;

  /**
   * The cached value of the '{@link #getRegistrationrole() <em>Registrationrole</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRegistrationrole()
   * @generated
   * @ordered
   */
  protected EList<RegistrationRole> registrationrole;

  /**
   * The cached value of the '{@link #getPrecondition() <em>Precondition</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPrecondition()
   * @generated
   * @ordered
   */
  protected EList<Precondition> precondition;

  /**
   * The cached value of the '{@link #getEffect() <em>Effect</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEffect()
   * @generated
   * @ordered
   */
  protected EList<Effect> effect;

  /**
   * The cached value of the '{@link #getResource() <em>Resource</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getResource()
   * @generated
   * @ordered
   */
  protected EList<Resource> resource;

  /**
   * The cached value of the '{@link #getProcess() <em>Process</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProcess()
   * @generated
   * @ordered
   */
  protected EList<org.xtext.example.mydsl7.myDsl.Process> process;

  /**
   * The cached value of the '{@link #getOwlowlclass() <em>Owlowlclass</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOwlowlclass()
   * @generated
   * @ordered
   */
  protected EList<ODM_OWLClass> owlowlclass;

  /**
   * The cached value of the '{@link #getRegisterplan() <em>Registerplan</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRegisterplan()
   * @generated
   * @ordered
   */
  protected EList<SS_RegisterPlan> registerplan;

  /**
   * The cached value of the '{@link #getFinder() <em>Finder</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFinder()
   * @generated
   * @ordered
   */
  protected EList<SS_FinderPlan> finder;

  /**
   * The cached value of the '{@link #getAgree() <em>Agree</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAgree()
   * @generated
   * @ordered
   */
  protected EList<SS_AgreementPlan> agree;

  /**
   * The cached value of the '{@link #getExe() <em>Exe</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExe()
   * @generated
   * @ordered
   */
  protected EList<SS_ExecutorPlan> exe;

  /**
   * The cached value of the '{@link #getGrounding() <em>Grounding</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGrounding()
   * @generated
   * @ordered
   */
  protected EList<Grounding> grounding;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SWSInteractionViewpointImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MyDslPackage.Literals.SWS_INTERACTION_VIEWPOINT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MyDslPackage.SWS_INTERACTION_VIEWPOINT__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SemanticWebAgent> getSemanticwebagent()
  {
    if (semanticwebagent == null)
    {
      semanticwebagent = new EObjectContainmentEList<SemanticWebAgent>(SemanticWebAgent.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__SEMANTICWEBAGENT);
    }
    return semanticwebagent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SWS> getSws()
  {
    if (sws == null)
    {
      sws = new EObjectContainmentEList<SWS>(SWS.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__SWS);
    }
    return sws;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Service> getService()
  {
    if (service == null)
    {
      service = new EObjectContainmentEList<Service>(Service.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__SERVICE);
    }
    return service;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<WebService> getWebservice()
  {
    if (webservice == null)
    {
      webservice = new EObjectContainmentEList<WebService>(WebService.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__WEBSERVICE);
    }
    return webservice;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Plan> getPlan()
  {
    if (plan == null)
    {
      plan = new EObjectContainmentEList<Plan>(Plan.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__PLAN);
    }
    return plan;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Role> getRole()
  {
    if (role == null)
    {
      role = new EObjectContainmentEList<Role>(Role.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__ROLE);
    }
    return role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Interface> getWinterface()
  {
    if (winterface == null)
    {
      winterface = new EObjectContainmentEList<Interface>(Interface.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINTERFACE);
    }
    return winterface;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Input> getWinput()
  {
    if (winput == null)
    {
      winput = new EObjectContainmentEList<Input>(Input.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINPUT);
    }
    return winput;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Output> getOutput()
  {
    if (output == null)
    {
      output = new EObjectContainmentEList<Output>(Output.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__OUTPUT);
    }
    return output;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RegistrationRole> getRegistrationrole()
  {
    if (registrationrole == null)
    {
      registrationrole = new EObjectContainmentEList<RegistrationRole>(RegistrationRole.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTRATIONROLE);
    }
    return registrationrole;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Precondition> getPrecondition()
  {
    if (precondition == null)
    {
      precondition = new EObjectContainmentEList<Precondition>(Precondition.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__PRECONDITION);
    }
    return precondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Effect> getEffect()
  {
    if (effect == null)
    {
      effect = new EObjectContainmentEList<Effect>(Effect.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__EFFECT);
    }
    return effect;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Resource> getResource()
  {
    if (resource == null)
    {
      resource = new EObjectContainmentEList<Resource>(Resource.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__RESOURCE);
    }
    return resource;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<org.xtext.example.mydsl7.myDsl.Process> getProcess()
  {
    if (process == null)
    {
      process = new EObjectContainmentEList<org.xtext.example.mydsl7.myDsl.Process>(org.xtext.example.mydsl7.myDsl.Process.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__PROCESS);
    }
    return process;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ODM_OWLClass> getOwlowlclass()
  {
    if (owlowlclass == null)
    {
      owlowlclass = new EObjectContainmentEList<ODM_OWLClass>(ODM_OWLClass.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__OWLOWLCLASS);
    }
    return owlowlclass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SS_RegisterPlan> getRegisterplan()
  {
    if (registerplan == null)
    {
      registerplan = new EObjectContainmentEList<SS_RegisterPlan>(SS_RegisterPlan.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTERPLAN);
    }
    return registerplan;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SS_FinderPlan> getFinder()
  {
    if (finder == null)
    {
      finder = new EObjectContainmentEList<SS_FinderPlan>(SS_FinderPlan.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__FINDER);
    }
    return finder;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SS_AgreementPlan> getAgree()
  {
    if (agree == null)
    {
      agree = new EObjectContainmentEList<SS_AgreementPlan>(SS_AgreementPlan.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__AGREE);
    }
    return agree;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SS_ExecutorPlan> getExe()
  {
    if (exe == null)
    {
      exe = new EObjectContainmentEList<SS_ExecutorPlan>(SS_ExecutorPlan.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__EXE);
    }
    return exe;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Grounding> getGrounding()
  {
    if (grounding == null)
    {
      grounding = new EObjectContainmentEList<Grounding>(Grounding.class, this, MyDslPackage.SWS_INTERACTION_VIEWPOINT__GROUNDING);
    }
    return grounding;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SEMANTICWEBAGENT:
        return ((InternalEList<?>)getSemanticwebagent()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SWS:
        return ((InternalEList<?>)getSws()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SERVICE:
        return ((InternalEList<?>)getService()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WEBSERVICE:
        return ((InternalEList<?>)getWebservice()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PLAN:
        return ((InternalEList<?>)getPlan()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__ROLE:
        return ((InternalEList<?>)getRole()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINTERFACE:
        return ((InternalEList<?>)getWinterface()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINPUT:
        return ((InternalEList<?>)getWinput()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OUTPUT:
        return ((InternalEList<?>)getOutput()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTRATIONROLE:
        return ((InternalEList<?>)getRegistrationrole()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PRECONDITION:
        return ((InternalEList<?>)getPrecondition()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EFFECT:
        return ((InternalEList<?>)getEffect()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__RESOURCE:
        return ((InternalEList<?>)getResource()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PROCESS:
        return ((InternalEList<?>)getProcess()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OWLOWLCLASS:
        return ((InternalEList<?>)getOwlowlclass()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTERPLAN:
        return ((InternalEList<?>)getRegisterplan()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__FINDER:
        return ((InternalEList<?>)getFinder()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__AGREE:
        return ((InternalEList<?>)getAgree()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EXE:
        return ((InternalEList<?>)getExe()).basicRemove(otherEnd, msgs);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__GROUNDING:
        return ((InternalEList<?>)getGrounding()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__NAME:
        return getName();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SEMANTICWEBAGENT:
        return getSemanticwebagent();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SWS:
        return getSws();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SERVICE:
        return getService();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WEBSERVICE:
        return getWebservice();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PLAN:
        return getPlan();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__ROLE:
        return getRole();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINTERFACE:
        return getWinterface();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINPUT:
        return getWinput();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OUTPUT:
        return getOutput();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTRATIONROLE:
        return getRegistrationrole();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PRECONDITION:
        return getPrecondition();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EFFECT:
        return getEffect();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__RESOURCE:
        return getResource();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PROCESS:
        return getProcess();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OWLOWLCLASS:
        return getOwlowlclass();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTERPLAN:
        return getRegisterplan();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__FINDER:
        return getFinder();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__AGREE:
        return getAgree();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EXE:
        return getExe();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__GROUNDING:
        return getGrounding();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__NAME:
        setName((String)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SEMANTICWEBAGENT:
        getSemanticwebagent().clear();
        getSemanticwebagent().addAll((Collection<? extends SemanticWebAgent>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SWS:
        getSws().clear();
        getSws().addAll((Collection<? extends SWS>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SERVICE:
        getService().clear();
        getService().addAll((Collection<? extends Service>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WEBSERVICE:
        getWebservice().clear();
        getWebservice().addAll((Collection<? extends WebService>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PLAN:
        getPlan().clear();
        getPlan().addAll((Collection<? extends Plan>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__ROLE:
        getRole().clear();
        getRole().addAll((Collection<? extends Role>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINTERFACE:
        getWinterface().clear();
        getWinterface().addAll((Collection<? extends Interface>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINPUT:
        getWinput().clear();
        getWinput().addAll((Collection<? extends Input>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OUTPUT:
        getOutput().clear();
        getOutput().addAll((Collection<? extends Output>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTRATIONROLE:
        getRegistrationrole().clear();
        getRegistrationrole().addAll((Collection<? extends RegistrationRole>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PRECONDITION:
        getPrecondition().clear();
        getPrecondition().addAll((Collection<? extends Precondition>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EFFECT:
        getEffect().clear();
        getEffect().addAll((Collection<? extends Effect>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__RESOURCE:
        getResource().clear();
        getResource().addAll((Collection<? extends Resource>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PROCESS:
        getProcess().clear();
        getProcess().addAll((Collection<? extends org.xtext.example.mydsl7.myDsl.Process>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OWLOWLCLASS:
        getOwlowlclass().clear();
        getOwlowlclass().addAll((Collection<? extends ODM_OWLClass>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTERPLAN:
        getRegisterplan().clear();
        getRegisterplan().addAll((Collection<? extends SS_RegisterPlan>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__FINDER:
        getFinder().clear();
        getFinder().addAll((Collection<? extends SS_FinderPlan>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__AGREE:
        getAgree().clear();
        getAgree().addAll((Collection<? extends SS_AgreementPlan>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EXE:
        getExe().clear();
        getExe().addAll((Collection<? extends SS_ExecutorPlan>)newValue);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__GROUNDING:
        getGrounding().clear();
        getGrounding().addAll((Collection<? extends Grounding>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__NAME:
        setName(NAME_EDEFAULT);
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SEMANTICWEBAGENT:
        getSemanticwebagent().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SWS:
        getSws().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SERVICE:
        getService().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WEBSERVICE:
        getWebservice().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PLAN:
        getPlan().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__ROLE:
        getRole().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINTERFACE:
        getWinterface().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINPUT:
        getWinput().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OUTPUT:
        getOutput().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTRATIONROLE:
        getRegistrationrole().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PRECONDITION:
        getPrecondition().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EFFECT:
        getEffect().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__RESOURCE:
        getResource().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PROCESS:
        getProcess().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OWLOWLCLASS:
        getOwlowlclass().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTERPLAN:
        getRegisterplan().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__FINDER:
        getFinder().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__AGREE:
        getAgree().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EXE:
        getExe().clear();
        return;
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__GROUNDING:
        getGrounding().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SEMANTICWEBAGENT:
        return semanticwebagent != null && !semanticwebagent.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SWS:
        return sws != null && !sws.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__SERVICE:
        return service != null && !service.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WEBSERVICE:
        return webservice != null && !webservice.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PLAN:
        return plan != null && !plan.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__ROLE:
        return role != null && !role.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINTERFACE:
        return winterface != null && !winterface.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__WINPUT:
        return winput != null && !winput.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OUTPUT:
        return output != null && !output.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTRATIONROLE:
        return registrationrole != null && !registrationrole.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PRECONDITION:
        return precondition != null && !precondition.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EFFECT:
        return effect != null && !effect.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__RESOURCE:
        return resource != null && !resource.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__PROCESS:
        return process != null && !process.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__OWLOWLCLASS:
        return owlowlclass != null && !owlowlclass.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__REGISTERPLAN:
        return registerplan != null && !registerplan.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__FINDER:
        return finder != null && !finder.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__AGREE:
        return agree != null && !agree.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__EXE:
        return exe != null && !exe.isEmpty();
      case MyDslPackage.SWS_INTERACTION_VIEWPOINT__GROUNDING:
        return grounding != null && !grounding.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }

} //SWSInteractionViewpointImpl
