package org.xtext.example.mydsl7.validation;

import org.eclipse.xtext.EcoreUtil2;
import org.eclipse.xtext.validation.Check;
import org.xtext.example.mydsl7.myDsl.MyDslPackage;
import org.xtext.example.mydsl7.myDsl.Plan;
import org.xtext.example.mydsl7.myDsl.SWSInteractionViewpoint;

import java.util.List;

public class MyDslJavaValidator extends AbstractMyDslJavaValidator {
	@Check
	public void checkOnlyTwoInstancesofPlan(Plan plan){
		SWSInteractionViewpoint main = EcoreUtil2.getContainerOfType(plan, SWSInteractionViewpoint.class);	
		List<Plan> plans = EcoreUtil2.getAllContentsOfType(main, Plan.class);
		if(plans.size()>2){
			error("Too many Plan objects", MyDslPackage.PLAN__NAME);
		}
	}
}
//Main: elements += (Type1|Type2)* ;
	//Type1: 'type1' name=ID ';' ;
	//Type2: 'type2' name=ID ';' ;


	//Your check function in Validator could look like:
	//Code: [Select all] [Show/ hide]
	//@Check
	//public void checkOnlyTwoInstancesOfType1(Type1 type1){
	/*	Main main = EcoreUtil2.getContainerOfType(type1, Main.class);
		List<Type1> type1s = EcoreUtil2.getAllContentsOfType(main, Type1.class);
		if(type1s.size()>2){
			error("Too many Type1 objects", MyDslPackage.Literals.TYPE1__NAME);
		}
	}*/