lexer grammar InternalMyDsl;
@header {
package org.xtext.example.mydsl3.ui.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.Lexer;
}

T11 : 'AgentInternalViewPoint' ;
T12 : '{' ;
T13 : '}' ;
T14 : 'Belief' ;
T15 : ';' ;
T16 : 'Goal' ;
T17 : 'Capabilities' ;
T18 : 'includes' ;
T19 : 'uses' ;
T20 : 'applies' ;
T21 : 'AgentState' ;
T22 : 'SemanticWebAgent' ;
T23 : 'contains' ;
T24 : 'plays' ;
T25 : 'has' ;
T26 : 'Role' ;
T27 : 'Plan' ;
T28 : 'dispatches' ;
T29 : 'AgentType' ;
T30 : 'Behaviour' ;
T31 : 'composed_of' ;
T32 : 'executes' ;

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5280
RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5282
RULE_INT : ('0'..'9')+;

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5284
RULE_STRING : ('"' ('\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\')|~(('\\'|'"')))* '"'|'\'' ('\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\')|~(('\\'|'\'')))* '\'');

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5286
RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5288
RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5290
RULE_WS : (' '|'\t'|'\r'|'\n')+;

// $ANTLR src "../org.xtext.example.mydsl3.ui/src-gen/org/xtext/example/mydsl3/ui/contentassist/antlr/internal/InternalMyDsl.g" 5292
RULE_ANY_OTHER : .;


